import pandapower as pp #import pandapower

def iotngin_network():

    net = pp.create_empty_network() #create an empty network

    # create the buses
    bus1 = pp.create_bus(net, vn_kv=20, name="np0008_000", geodata=(12.59, 42.537051), type='b', in_service=True, max_vm_pu=1.1, min_vm_pu=0.9)
    bus2 = pp.create_bus(net, vn_kv=20, name="nm0657_001", geodata=(12.593, 42.537051), type='b', in_service=True, max_vm_pu=1.1, min_vm_pu=0.9)
    bus3 = pp.create_bus(net, vn_kv=20, name="nm0657_002", geodata=(12.596, 42.537051), type='b', in_service=True, max_vm_pu=1.1, min_vm_pu=0.9)
    bus4 = pp.create_bus(net, vn_kv=20, name="nm0657_003", geodata=(12.599, 42.537051), type='b', in_service=True, max_vm_pu=1.1, min_vm_pu=0.9)
    bus5 = pp.create_bus(net, vn_kv=20, name="ns0486_000", geodata=(12.619224, 42.537051), type='b', in_service=True, max_vm_pu=1.1, min_vm_pu=0.9)
    bus6 = pp.create_bus(net, vn_kv=20, name="nm0658_001", geodata=(12.62, 42.537051), type='b', in_service=True, max_vm_pu=1.1, min_vm_pu=0.9)
    bus7 = pp.create_bus(net, vn_kv=20, name="nd0098_000", geodata=(12.62082, 42.537051), type='b', in_service=True, max_vm_pu=1.1, min_vm_pu=0.9)
    bus8 = pp.create_bus(net, vn_kv=20, name="ns0487_000", geodata=(12.62082, 42.535367), type='b', in_service=True, max_vm_pu=1.1, min_vm_pu=0.9)
    bus9 = pp.create_bus(net, vn_kv=20, name="nd0099_000", geodata=(12.61418, 42.534051), type='b', in_service=True, max_vm_pu=1.1, min_vm_pu=0.9)
    bus10 = pp.create_bus(net, vn_kv=20, name="ns0488_000", geodata=(12.60618, 42.532051), type='b', in_service=True, max_vm_pu=1.1, min_vm_pu=0.9)
    bus11 = pp.create_bus(net, vn_kv=20, name="nd0100_000", geodata=(12.600053, 42.530423), type='b', in_service=True, max_vm_pu=1.1, min_vm_pu=0.9)
    bus12 = pp.create_bus(net, vn_kv=20, name="ns0489_000", geodata=(12.603214, 42.532388), type='b', in_service=True, max_vm_pu=1.1, min_vm_pu=0.9)
    bus13 = pp.create_bus(net, vn_kv=20, name="nd0101_000", geodata=(12.607, 42.530423), type='b', in_service=True, max_vm_pu=1.1, min_vm_pu=0.9)
    bus14 = pp.create_bus(net, vn_kv=20, name="ns0490_000", geodata=(12.600157, 42.530423), type='b', in_service=True, max_vm_pu=1.1, min_vm_pu=0.9)
    bus15 = pp.create_bus(net, vn_kv=20, name="ns0491_000", geodata=(12.600053, 42.530385), type='b', in_service=True, max_vm_pu=1.1, min_vm_pu=0.9)
    bus16 = pp.create_bus(net, vn_kv=20, name="nd0102_000", geodata=(12.63418, 42.531), type='b', in_service=True, max_vm_pu=1.1, min_vm_pu=0.9)
    bus17 = pp.create_bus(net, vn_kv=20, name="ns0492_000", geodata=(12.63418, 42.526908), type='b', in_service=True, max_vm_pu=1.1, min_vm_pu=0.9)
    bus18 = pp.create_bus(net, vn_kv=20, name="nd0103_000", geodata=(12.622921, 42.531), type='b', in_service=True, max_vm_pu=1.1, min_vm_pu=0.9)
    bus19 = pp.create_bus(net, vn_kv=20, name="nd0103_001", geodata=(12.627205, 42.529751), type='b', in_service=True, max_vm_pu=1.1, min_vm_pu=0.9)
    bus20 = pp.create_bus(net, vn_kv=20, name="ns0749_000", geodata=(12.621205, 42.529751), type='b', in_service=True, max_vm_pu=1.1, min_vm_pu=0.9)
    bus21 = pp.create_bus(net, vn_kv=20, name="ns0493_000", geodata=(12.620421, 42.524806), type='b', in_service=True, max_vm_pu=1.1, min_vm_pu=0.9)
    bus22 = pp.create_bus(net, vn_kv=20, name="ns0494_000", geodata=(12.623494, 42.520911), type='b', in_service=True, max_vm_pu=1.1, min_vm_pu=0.9)
    bus23 = pp.create_bus(net, vn_kv=20, name="nm0970_001", geodata=(12.623594, 42.518011), type='b', in_service=True, max_vm_pu=1.1, min_vm_pu=0.9)
    bus24 = pp.create_bus(net, vn_kv=20, name="ns0747_000", geodata=(12.623702, 42.513762), type='b', in_service=True, max_vm_pu=1.1, min_vm_pu=0.9)
    bus25 = pp.create_bus(net, vn_kv=20, name="nd0104_001", geodata=(12.6183, 42.5213), type='b', in_service=True, max_vm_pu=1.1, min_vm_pu=0.9)
    bus26 = pp.create_bus(net, vn_kv=20, name="ns0495_000", geodata=(12.614082, 42.522281), type='b', in_service=True, max_vm_pu=1.1, min_vm_pu=0.9)
    bus27 = pp.create_bus(net, vn_kv=20, name="nd0105_000", geodata=(12.621339, 42.519436), type='b', in_service=True, max_vm_pu=1.1, min_vm_pu=0.9)
    bus28 = pp.create_bus(net, vn_kv=20, name="ns0496_000", geodata=(12.620339, 42.517436), type='b', in_service=True, max_vm_pu=1.1, min_vm_pu=0.9)
    bus29 = pp.create_bus(net, vn_kv=20, name="nm0971_001", geodata=(12.6173, 42.5173), type='b', in_service=True, max_vm_pu=1.1, min_vm_pu=0.9)
    bus30 = pp.create_bus(net, vn_kv=20, name="ns0748_000", geodata=(12.615794, 42.513827), type='b', in_service=True, max_vm_pu=1.1, min_vm_pu=0.9)
    bus31 = pp.create_bus(net, vn_kv=20, name="nd0104_000", geodata=(12.618, 42.521611), type='b', in_service=True, max_vm_pu=1.1, min_vm_pu=0.9)

    # create the external grid connection
    pp.create_ext_grid(net, pp.get_element_index(net, "bus", "np0008_000"), vm_pu=1.0, va_degree=0.0, name="ASM_Grid", in_service=True, s_sc_max_mva=31000, rx_max=0.125, r0x0_max=0.25)

    # create the linecodes
    pp.create_std_type(net, data={"r_ohm_per_km":0.206, "x_ohm_per_km":0.105, "c_nf_per_km":287, "max_i_ka":335, "type":"cs"}, name="Al_150_UC", element='line', overwrite=True, check_required=True)
    pp.create_std_type(net, data={"r_ohm_per_km":0.387, "x_ohm_per_km":0.125, "c_nf_per_km":195, "max_i_ka":177, "type":"cs"}, name="Cu_50_UC", element='line', overwrite=True, check_required=True)
    pp.create_std_type(net, data={"r_ohm_per_km":0.519, "x_ohm_per_km":0.370, "c_nf_per_km":9.71, "max_i_ka":180, "type":"cs"}, name="Cu_35_OL", element='line', overwrite=True, check_required=True)
    pp.create_std_type(net, data={"r_ohm_per_km":0.712, "x_ohm_per_km":0.381, "c_nf_per_km":9.41, "max_i_ka":100, "type":"cs"}, name="Cu_25_OL", element='line', overwrite=True, check_required=True)
    pp.create_std_type(net, data={"r_ohm_per_km":0.164, "x_ohm_per_km":0.101, "c_nf_per_km":315, "max_i_ka":360, "type":"cs"}, name="Al_185_UC", element='line', overwrite=True, check_required=True)
    pp.create_std_type(net, data={"r_ohm_per_km":1.12, "x_ohm_per_km":0.396, "c_nf_per_km":9.07, "max_i_ka":100, "type":"cs"}, name="Cu_16_OL", element='line', overwrite=True, check_required=True)


    # create the lines
    line1 = pp.create_line(net, from_bus=pp.get_element_index(net, "bus", "np0008_000"), to_bus=pp.get_element_index(net, "bus", "nm0657_001"), length_km=0.025, std_type="Al_150_UC", name="LN0657_001")
    line2 = pp.create_line(net, from_bus=pp.get_element_index(net, "bus", "nm0657_001"), to_bus=pp.get_element_index(net, "bus", "nm0657_002"), length_km=0.034, std_type="Cu_50_UC", name="LN0657_002")
    line3 = pp.create_line(net, from_bus=pp.get_element_index(net, "bus", "nm0657_002"), to_bus=pp.get_element_index(net, "bus", "nm0657_003"), length_km=0.95, std_type="Cu_35_OL", name="LN0657_003")
    line4 = pp.create_line(net, from_bus=pp.get_element_index(net, "bus", "nm0657_003"), to_bus=pp.get_element_index(net, "bus", "ns0486_000"), length_km=0.11, std_type="Cu_50_UC", name="LN0657_004")
    line5 = pp.create_line(net, from_bus=pp.get_element_index(net, "bus", "ns0486_000"), to_bus=pp.get_element_index(net, "bus", "nm0658_001"), length_km=0.1, std_type="Cu_50_UC", name="LN0658_001")
    line6 = pp.create_line(net, from_bus=pp.get_element_index(net, "bus", "nm0658_001"), to_bus=pp.get_element_index(net, "bus", "nd0098_000"), length_km=0.375, std_type="Cu_35_OL", name="LN0658_002")
    line7 = pp.create_line(net, from_bus=pp.get_element_index(net, "bus", "nd0098_000"), to_bus=pp.get_element_index(net, "bus", "ns0487_000"), length_km=0.1, std_type="Cu_16_OL", name="LN0659_001")
    line8 = pp.create_line(net, from_bus=pp.get_element_index(net, "bus", "nd0098_000"), to_bus=pp.get_element_index(net, "bus", "nd0099_000"), length_km=0.3, std_type="Cu_35_OL", name="LN0660_001")
    line9 = pp.create_line(net, from_bus=pp.get_element_index(net, "bus", "nd0099_000"), to_bus=pp.get_element_index(net, "bus", "ns0488_000"), length_km=0.15, std_type="Cu_16_OL", name="LN0661_001")
    line10 = pp.create_line(net, from_bus=pp.get_element_index(net, "bus", "ns0488_000"), to_bus=pp.get_element_index(net, "bus", "nd0100_000"), length_km=0.4, std_type="Cu_16_OL", name="LN0662_001")
    line11 = pp.create_line(net, from_bus=pp.get_element_index(net, "bus", "nd0100_000"), to_bus=pp.get_element_index(net, "bus", "ns0489_000"), length_km=0.05, std_type="Cu_16_OL", name="LN0663_001")
    line12 = pp.create_line(net, from_bus=pp.get_element_index(net, "bus", "nd0100_000"), to_bus=pp.get_element_index(net, "bus", "nd0101_000"), length_km=1.05, std_type="Cu_16_OL", name="LN0664_001")
    line13 = pp.create_line(net, from_bus=pp.get_element_index(net, "bus", "nd0101_000"), to_bus=pp.get_element_index(net, "bus", "ns0490_000"), length_km=0.56, std_type="Cu_25_OL", name="LN0665_001")
    line14 = pp.create_line(net, from_bus=pp.get_element_index(net, "bus", "nd0101_000"), to_bus=pp.get_element_index(net, "bus", "ns0491_000"), length_km=0.35, std_type="Cu_16_OL", name="LN0666_001")
    line15 = pp.create_line(net, from_bus=pp.get_element_index(net, "bus", "nd0099_000"), to_bus=pp.get_element_index(net, "bus", "nd0102_000"), length_km=0.75, std_type="Cu_35_OL", name="LN0667_001")
    line16 = pp.create_line(net, from_bus=pp.get_element_index(net, "bus", "nd0102_000"), to_bus=pp.get_element_index(net, "bus", "ns0492_000"), length_km=0.9, std_type="Cu_16_OL", name="LN0668_001")
    line17 = pp.create_line(net, from_bus=pp.get_element_index(net, "bus", "nd0102_000"), to_bus=pp.get_element_index(net, "bus", "nd0103_000"), length_km=0.145, std_type="Cu_35_OL", name="LN0669_001")
    line18 = pp.create_line(net, from_bus=pp.get_element_index(net, "bus", "nd0103_001"), to_bus=pp.get_element_index(net, "bus", "ns0749_000"), length_km=0.277, std_type="Al_185_UC", name="LN0669_002")
    line19 = pp.create_line(net, from_bus=pp.get_element_index(net, "bus", "nd0103_000"), to_bus=pp.get_element_index(net, "bus", "ns0493_000"), length_km=0.03, std_type="Cu_16_OL", name="LN0670_001")
    line20 = pp.create_line(net, from_bus=pp.get_element_index(net, "bus", "ns0494_000"), to_bus=pp.get_element_index(net, "bus", "nm0970_001"), length_km=0.5, std_type="Cu_35_OL", name="LN0670_002")
    line21 = pp.create_line(net, from_bus=pp.get_element_index(net, "bus", "nm0970_001"), to_bus=pp.get_element_index(net, "bus", "ns0747_000"), length_km=0.03, std_type="Al_185_UC", name="LN0670_003")
    line22 = pp.create_line(net, from_bus=pp.get_element_index(net, "bus", "nd0103_000"), to_bus=pp.get_element_index(net, "bus", "nd0103_001"), length_km=0.055, std_type="Cu_35_OL", name="LN0671_001")
    line23 = pp.create_line(net, from_bus=pp.get_element_index(net, "bus", "nd0103_001"), to_bus=pp.get_element_index(net, "bus", "ns0494_000"), length_km=0.555, std_type="Cu_35_OL", name="LN0671_002")
    line24 = pp.create_line(net, from_bus=pp.get_element_index(net, "bus", "ns0494_000"), to_bus=pp.get_element_index(net, "bus", "nd0104_001"), length_km=0.33, std_type="Cu_16_OL", name="LN0672_001")
    line25 = pp.create_line(net, from_bus=pp.get_element_index(net, "bus", "nd0104_001"), to_bus=pp.get_element_index(net, "bus", "ns0495_000"), length_km=0.5, std_type="Cu_25_OL", name="LN0673_001")
    line26 = pp.create_line(net, from_bus=pp.get_element_index(net, "bus", "nd0104_001"), to_bus=pp.get_element_index(net, "bus", "nd0105_000"), length_km=0.277, std_type="Cu_16_OL", name="LN0674_001")
    line27 = pp.create_line(net, from_bus=pp.get_element_index(net, "bus", "nd0105_000"), to_bus=pp.get_element_index(net, "bus", "ns0496_000"), length_km=0.15, std_type="Cu_16_OL", name="LN0675_001")
    line28 = pp.create_line(net, from_bus=pp.get_element_index(net, "bus", "nd0104_001"), to_bus=pp.get_element_index(net, "bus", "nm0971_001"), length_km=0.175, std_type="Cu_16_OL", name="LN0676_001")
    line29 = pp.create_line(net, from_bus=pp.get_element_index(net, "bus", "nm0971_001"), to_bus=pp.get_element_index(net, "bus", "ns0748_000"), length_km=0.23, std_type="Al_185_UC", name="LN0671_002")
    line30 = pp.create_line(net, from_bus=pp.get_element_index(net, "bus", "nd0104_000"), to_bus=pp.get_element_index(net, "bus", "nd0104_001"), length_km=0.175, std_type="Cu_16_OL", name="LN0671_003")


    # create domestic loads
    pp.create_load(net, bus=pp.get_element_index(net, "bus", "ns0490_000"), p_mw=0.050, q_mvar=0, name="Load_D_490", scaling=1.0, in_service=True, type='wye')
    pp.create_load(net, bus=pp.get_element_index(net, "bus", "ns0495_000"), p_mw=0.050, q_mvar=0, name="Load_D_495", scaling=1.0, in_service=True, type='wye')
    pp.create_load(net, bus=pp.get_element_index(net, "bus", "ns0494_000"), p_mw=0.050, q_mvar=0, name="Load_D_494", scaling=1.0, in_service=True, type='wye')
    pp.create_load(net, bus=pp.get_element_index(net, "bus", "ns0749_000"), p_mw=0.050, q_mvar=0, name="Load_D_749", scaling=1.0, in_service=True, type='wye')
    pp.create_load(net, bus=pp.get_element_index(net, "bus", "ns0486_000"), p_mw=0.050, q_mvar=0, name="Load_D_486", scaling=1.0, in_service=True, type='wye')
    pp.create_load(net, bus=pp.get_element_index(net, "bus", "ns0487_000"), p_mw=0.050, q_mvar=0, name="Load_D_487", scaling=1.0, in_service=True, type='wye')
    pp.create_load(net, bus=pp.get_element_index(net, "bus", "ns0493_000"), p_mw=0.050, q_mvar=0, name="Load_D_493", scaling=1.0, in_service=True, type='wye')
    pp.create_load(net, bus=pp.get_element_index(net, "bus", "ns0748_000"), p_mw=0.050, q_mvar=0, name="Load_D_748", scaling=1.0, in_service=True, type='wye')
    pp.create_load(net, bus=pp.get_element_index(net, "bus", "ns0747_000"), p_mw=0.050, q_mvar=0, name="Load_D_747", scaling=1.0, in_service=True, type='wye')
    pp.create_load(net, bus=pp.get_element_index(net, "bus", "ns0492_000"), p_mw=0.050, q_mvar=0, name="Load_D_492", scaling=1.0, in_service=True, type='wye')
    pp.create_load(net, bus=pp.get_element_index(net, "bus", "ns0489_000"), p_mw=0.050, q_mvar=0, name="Load_D_489", scaling=1.0, in_service=True, type='wye')
    pp.create_load(net, bus=pp.get_element_index(net, "bus", "ns0491_000"), p_mw=0.050, q_mvar=0, name="Load_D_491", scaling=1.0, in_service=True, type='wye')
    pp.create_load(net, bus=pp.get_element_index(net, "bus", "ns0496_000"), p_mw=0.050, q_mvar=0, name="Load_D_496", scaling=1.0, in_service=True, type='wye')

    # create industrial loads
    pp.create_load(net, bus=pp.get_element_index(net, "bus", "ns0490_000"), p_mw=0.050, q_mvar=0, name="Load_I_490", scaling=1.0, in_service=True, type='wye')
    pp.create_load(net, bus=pp.get_element_index(net, "bus", "ns0495_000"), p_mw=0.050, q_mvar=0, name="Load_I_495", scaling=1.0, in_service=True, type='wye')
    pp.create_load(net, bus=pp.get_element_index(net, "bus", "ns0494_000"), p_mw=0.050, q_mvar=0, name="Load_I_494", scaling=1.0, in_service=True, type='wye')
    pp.create_load(net, bus=pp.get_element_index(net, "bus", "ns0749_000"), p_mw=0.050, q_mvar=0, name="Load_I_749", scaling=1.0, in_service=True, type='wye')
    pp.create_load(net, bus=pp.get_element_index(net, "bus", "ns0486_000"), p_mw=0.050, q_mvar=0, name="Load_I_486", scaling=1.0, in_service=True, type='wye')
    pp.create_load(net, bus=pp.get_element_index(net, "bus", "ns0487_000"), p_mw=0.050, q_mvar=0, name="Load_I_487", scaling=1.0, in_service=True, type='wye')
    pp.create_load(net, bus=pp.get_element_index(net, "bus", "ns0493_000"), p_mw=0.050, q_mvar=0, name="Load_I_493", scaling=1.0, in_service=True, type='wye')
    pp.create_load(net, bus=pp.get_element_index(net, "bus", "ns0748_000"), p_mw=0.050, q_mvar=0, name="Load_I_748", scaling=1.0, in_service=True, type='wye')
    pp.create_load(net, bus=pp.get_element_index(net, "bus", "ns0747_000"), p_mw=0.050, q_mvar=0, name="Load_I_747", scaling=1.0, in_service=True, type='wye')
    pp.create_load(net, bus=pp.get_element_index(net, "bus", "ns0492_000"), p_mw=0.050, q_mvar=0, name="Load_I_492", scaling=1.0, in_service=True, type='wye')
    pp.create_load(net, bus=pp.get_element_index(net, "bus", "ns0489_000"), p_mw=0.050, q_mvar=0, name="Load_I_489", scaling=1.0, in_service=True, type='wye')
    pp.create_load(net, bus=pp.get_element_index(net, "bus", "ns0491_000"), p_mw=0.050, q_mvar=0, name="Load_I_491", scaling=1.0, in_service=True, type='wye')
    pp.create_load(net, bus=pp.get_element_index(net, "bus", "ns0496_000"), p_mw=0.050, q_mvar=0, name="Load_I_496", scaling=1.0, in_service=True, type='wye')


    # create the PV plants
    pp.create_sgen(net, bus=pp.get_element_index(net, "bus", "ns0490_000"), p_mw=0.050, q_mvar=0, name="PV_490")
    pp.create_sgen(net, bus=pp.get_element_index(net, "bus", "ns0495_000"), p_mw=0.050, q_mvar=0, name="PV_495")
    pp.create_sgen(net, bus=pp.get_element_index(net, "bus", "ns0494_000"), p_mw=0.050, q_mvar=0, name="PV_494")
    pp.create_sgen(net, bus=pp.get_element_index(net, "bus", "ns0749_000"), p_mw=0.050, q_mvar=0, name="PV_749")
    pp.create_sgen(net, bus=pp.get_element_index(net, "bus", "ns0486_000"), p_mw=0.050, q_mvar=0, name="PV_486")
    pp.create_sgen(net, bus=pp.get_element_index(net, "bus", "ns0487_000"), p_mw=0.050, q_mvar=0, name="PV_487")
    pp.create_sgen(net, bus=pp.get_element_index(net, "bus", "ns0493_000"), p_mw=0.050, q_mvar=0, name="PV_493")
    pp.create_sgen(net, bus=pp.get_element_index(net, "bus", "ns0748_000"), p_mw=0.050, q_mvar=0, name="PV_748")
    pp.create_sgen(net, bus=pp.get_element_index(net, "bus", "ns0747_000"), p_mw=0.050, q_mvar=0, name="PV_747")
    pp.create_sgen(net, bus=pp.get_element_index(net, "bus", "ns0492_000"), p_mw=0.050, q_mvar=0, name="PV_492")
    pp.create_sgen(net, bus=pp.get_element_index(net, "bus", "ns0489_000"), p_mw=0.050, q_mvar=0, name="PV_489")
    pp.create_sgen(net, bus=pp.get_element_index(net, "bus", "ns0491_000"), p_mw=0.050, q_mvar=0, name="PV_491")
    pp.create_sgen(net, bus=pp.get_element_index(net, "bus", "ns0496_000"), p_mw=0.050, q_mvar=0, name="PV_496")

    return net